CREATE OR REPLACE VDS janj.reflection_use_test AS
SELECT rut.numberA, rut.idA, rut.numberB, rut.idB, rut.start_ts, rut.end_ts, rut.unused_int, rut.unused_string, rut.record_type,
       CAST(DATE_TRUNC('day', rut.start_ts) AS DATE) AS day_date
from minio.janj."reflection_use_test" rut

CREATE OR REPLACE VDS janj.v_a_as_a AS
SELECT
  numberA,
  idA,
  numberB,
  idB,
  start_ts,
  end_ts,
  record_type,
  day_date
from janj.reflection_use_test;

CREATE OR REPLACE VDS janj.v_b_as_a AS
SELECT
  numberA AS numberB,
  idA AS idB,
  numberB AS numberA,
  idB AS idA,
  start_ts,
  end_ts,
  CASE record_type
    WHEN 'NORMAL' THEN 'INVERSE'
    WHEN 'INVERSE' THEN 'NORMAL'
    ELSE record_type
    END AS record_type,
  day_date
from janj.reflection_use_test;

CREATE OR REPLACE VDS janj.v_combined AS
SELECT
  numberA, idA, numberB, idB,
  start_ts, end_ts,
  record_type, day_date
FROM
  janj.v_a_as_a
UNION ALL
SELECT
  numberA, idA, numberB, idB,
  start_ts, end_ts,
  record_type, day_date
FROM
  janj.v_b_as_a;

CREATE OR REPLACE VDS janj.v_unidirectional AS
SELECT
  numberA, max(idA) AS idA, numberB, max(idB) AS idB,
  start_ts, end_ts,
  record_type, day_date
FROM
  janj.v_combined
GROUP BY
  numberA, numberB, start_ts, end_ts, record_type, day_date;
